%def_with debug
%def_with native

Name: tcerl
%define VSN 1.3.1
Version: %{VSN}f
Release: alt1
Summary: Erlang driver for Tokyo Cabinet
License: Open Source
Group: Development/Erlang
URL: http://%name.googlecode.com
Source: %url/files/%name-%version.tar
Patch: %name-%version-%release.patch
Packager: Led <led@altlinux.ru>

BuildRequires(pre): rpm-macros-erlang >= 0.7.0
BuildRequires: erlang erlang-otp-devel rpm-build-erlang symlinks
BuildRequires: erlang_mod(beam_strip)
BuildRequires: fw-template-erlang >= 0.1.37-alt2

%description
Erlang driver for Tokyo Cabinet.


%package -n erlang-%name-common
Summary: Erlang driver for Tokyo Cabinet - common files
Group: Development/Erlang
BuildArch: noarch
Requires: erlang-otp-common >= R12B.5

%description -n erlang-%name-common
Erlang driver for Tokyo Cabinet.
This package contains common files for %name.


%package -n erlang-%name
Summary: Erlang driver for Tokyo Cabinet
Group: Development/Erlang
BuildArch: noarch
Requires: %{name}drv = %VSN
Requires: erlang-%name-common = %version-%release

%description -n erlang-%name
Erlang driver for Tokyo Cabinet.


%package -n erlang-%name-src
Summary: Sources of Erlang driver for Tokyo Cabinet
Group: Development/Erlang
BuildArch: noarch
Requires: erlang-%name-common = %version-%release

%description -n erlang-%name-src
Sources of Erlang driver for Tokyo Cabinet.


%if_with debug
%package -n erlang-%name-debug
Summary: Erlang driver for Tokyo Cabinet - modules with debug information
Group: Development/Erlang
BuildArch: noarch
Requires: %{name}drv = %VSN
Requires: erlang-%name-common = %version-%release

%description -n erlang-%name-debug
Erlang driver for Tokyo Cabinet.
This package contains modules with debug information.
%endif


%if_with native
%package -n erlang-%name-native
Summary: Erlang driver for Tokyo Cabinet - modules with native CPU code
Group: Development/Erlang
Requires: %{name}drv = %VSN
Requires: erlang-%name-common = %version-%release

%description -n erlang-%name-native
Erlang driver for Tokyo Cabinet.
This package contains modules with native CPU code.
%endif


%package doc
Summary: Documentation for Erlang driver for Tokyo Cabinet
Group: Development/Documentation
BuildArch: noarch
Provides: erlang-%name-doc = %version-%release
Requires: erlang-otp-common

%description doc
Documentation for Erlang driver for Tokyo Cabinet.


%prep
%setup
%patch -p1
sed -i -r -e 's/[[:blank:]]--revision[[:blank:]]+svn/ /g' bootstrap


%build
./bootstrap
%configure \
    --disable-erlrc \
    ERLAPPDIR=%_otplibdir/%name-%VSN \
    ERLDOCDIR=%_otplibdir/%name-%VSN/doc \
    ERLC=%__erlc
%make_build ERLC_FLAGS="%{?_with_debug:+debug_info} %{?_with_native:+native +'{hipe,[o3]}'}"


%install
%make_install DESTDIR=%buildroot install
chmod 644 %buildroot%_otplibdir/%name-%VSN/ebin/*
install -d -m 0755 %buildroot%_docdir/%name-%version
ln -sf %buildroot{%_otplibdir/%name-%VSN/doc,%_docdir/%name-%version/html}
symlinks -csd %buildroot%_docdir/%name-%version
install -m 0644 AUTHORS COPYING ChangeLog README TODO %buildroot%_docdir/%name-%version/

%if_with debug
install -d -m 0755 %buildroot%_otplibdebugdir/%name-%VSN/ebin
%__erlang -noshell -run beam_strip start -run erlang halt -extra -o %buildroot%_otplibdebugdir/%name-%VSN/ebin -A -r CInf -c %buildroot%_otplibdir/%name-%VSN/ebin/*.beam
%endif
%if_with native
install -d -m 0755 %buildroot%_otplibnativedir/%name-%VSN/ebin
%__erlang -noshell -run beam_strip start -run erlang halt -extra -o %buildroot%_otplibnativedir/%name-%VSN/ebin -s -c %buildroot%_otplibdir/%name-%VSN/ebin/*.beam
%endif
%__erlang -noshell -run beam_strip start -run erlang halt -extra -s -A %buildroot%_otplibdir/%name-%VSN/ebin/*.beam


%files -n erlang-%name-common
%doc %dir %_docdir/%name-%version
%doc %_docdir/%name-%version/AUTHORS
%doc %_docdir/%name-%version/COPYING
%doc %_docdir/%name-%version/README
%dir %_otplibdir/%name-*
%dir %_otplibdir/%name-*/ebin
%_otplibdir/%name-*/ebin/*.app


%files -n erlang-%name
%_otplibdir/%name-*/ebin/*.beam


%files -n erlang-%name-src
%_otplibdir/%name-*/src


%if_with debug
%files -n erlang-%name-debug
%dir %_otplibdebugdir
%_otplibdebugdir/*
%endif


%if_with native
%files -n erlang-%name-native
%dir %_otplibnativedir
%_otplibnativedir/*
%endif


%files doc
%dir %_otplibdir/%name-*
%_otplibdir/%name-*/doc
%dir %_docdir/%name-%version
%_docdir/%name-%version/html
%_docdir/%name-%version/ChangeLog
%_docdir/%name-%version/TODO


%changelog
* Mon Mar 02 2009 Led <led@altlinux.ru> 1.3.1f-alt1
- 1.3.1f
- added ability to build debug and native modules
- strip modules
- added erlang-%name-common subpackage
- added erlang-%name-src subpackage
- enabled debug modules
- enabled native modules

* Sun Oct 05 2008 Led <led@altlinux.ru> 1.3.1-alt3
- fixed BuildRequires

* Fri Sep 12 2008 Led <led@altlinux.ru> 1.3.1-alt2
- fixed requires

* Fri Aug 01 2008 Led <led@altlinux.ru> 1.3.1-alt1
- 1.3.1

* Sun Jul 27 2008 Led <led@altlinux.ru> 1.2.5f-alt1
- initial build
